//+----------------------------------------------------------------------------+
//|                                                           e_ForTester.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  05.10.2008       .                  |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"

//-------    -----------------------------------------+
extern int StopLoss   = 55;
extern int TakeProfit = 165;

//-------    -------------------------------------+
double Lots         = 0.1;             //   
color  clOpenBuy    = LightBlue;       //    
color  clOpenSell   = LightCoral;      //    
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    
color  clCloseBuy   = Blue;            //   
color  clCloseSell  = Red;             //   
int    Slippage     = 3;               //  
int    BeginTest;                      //   

//-------    -----------------------------------------+
#include <stdlib.mqh>                  //  


//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|  expert initialization function                                            |
//+----------------------------------------------------------------------------+
void init() {
  if (IsTesting()) BeginTest=GetTickCount();
}

//+----------------------------------------------------------------------------+
//|  expert deinitialization function                                          |
//+----------------------------------------------------------------------------+
void deinit() {
  if (IsTesting()) Print("  ",
                         NormalizeDouble((GetTickCount()-BeginTest)/1000.0, 1),
                         " .");
}

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  if(DayOfWeek()==0 || DayOfWeek()==6) return;
  if (IsTesting()) ManagePositions();
}


//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  double pp;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS);

  if (OrderType()==OP_BUY) {
    pp=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_BID), dg);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
  }
  if (OrderType()==OP_SELL) {
    pp=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_ASK), dg);
    OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 03.08.2008                                                     |
//|   :     .                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    mo -                                      |
//|    mn - MagicNumber                          (-1 -  )            |
//+----------------------------------------------------------------------------+
void CountOrders(int& mo[], int mn=-1) {
  int i, k=OrdersTotal();

  if (ArraySize(mo)!=6) ArrayResize(mo, 6);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (mn<0 || OrderMagicNumber()==mn) mo[OrderType()]++;
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|    :                                               |
//|     1 -                                                             |
//|     0 - ,                                                    |
//|    -1 -                                                            |
//+----------------------------------------------------------------------------+
int GetTradeSignal() {
  int bs=0;

  if (Open[2]>Close[2] && Open[1]>Close[1]) bs=+1;
  if (Open[2]<Close[2] && Open[1]<Close[1]) bs=-1;

  return(bs);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.02.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|                                                         |
//+----------------------------------------------------------------------------+
void ManagePositions() {
  double sl=0, tp=0;
  int    bs=GetTradeSignal(), mo[6];

  ArrayInitialize(mo, 0);
  CountOrders(mo);

  if (bs>0) {
    if (mo[1]>0) ClosePositions(NULL, OP_SELL);
    if (mo[0]<1) {
      sl=IIFd(StopLoss  >0, Ask-StopLoss  *Point, 0);
      tp=IIFd(TakeProfit>0, Ask+TakeProfit*Point, 0);
      OpenPosition(NULL, OP_BUY, Lots, sl, tp);
    }
  }
  if (bs<0) {
    if (mo[0]>0) ClosePositions(NULL, OP_BUY);
    if (mo[1]<1) {
      sl=IIFd(StopLoss  >0, Bid+StopLoss  *Point, 0);
      tp=IIFd(TakeProfit>0, Bid-TakeProfit*Point, 0);
      OpenPosition(NULL, OP_SELL, Lots, sl, tp);
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 13.06.2007                                                     |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""  NULL -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  color  clOpen;
  double pp;
  int    err, ticket;

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) {
    pp=MarketInfo(sy, MODE_ASK); clOpen=clOpenBuy;
  } else {
    pp=MarketInfo(sy, MODE_BID); clOpen=clOpenSell;
  }
  ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn, 0, clOpen);
  if (ticket<0) {
    err=GetLastError();
    Print("Error(",err,") open ",GetNameOP(op),": ",ErrorDescription(err));
    Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
          " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
  }
}
//+----------------------------------------------------------------------------+

